#include <bits/stdc++.h>

using namespace std;
int n = 21,m = 1;
vector<vector<int> > edges(n,vector<int>(n,0)),sym;
vector<pair<int,int> > pairs(1);
vector<vector<bool> > ans;
vector<bool> afterSym,curr,used;
vector<int> CurrSym(1);
int length = 0,NotAdded = 0;

void ReadData(){
    freopen("polyedr.in","r",stdin);
    string s;
    int i = 0,z;
    while(getline(cin,s)){
        i++;
        stringstream ss(s);
        vector<int> dots;
        while(!ss.eof()){
            ss >> z;
            dots.push_back(z);
        }
        sort(dots.begin(),dots.end());
        for(z = 0;z<dots.size();z++){
            if(dots[z] < i) continue;
            edges[dots[z]][i] = edges[i][dots[z]] = m++;
            pairs.push_back(make_pair(i,dots[z]));

        }
    }
    n = i+1;
    curr.assign(m,0);
}
vector<bool> GetSym(int a){
    vector<bool> b(m,0);
    for(int i = 1;i<m;i++){
        if(curr[i]){
            int dot1 = pairs[i].first;
            int dot2 = pairs[i].second;
            dot1 = sym[a][dot1];
            dot2 = sym[a][dot2];
            b[edges[dot1][dot2]] = 1;
        }
    }
    return b;
}
void add(){
    for(int i = 0;i<sym.size();i++){
        afterSym = GetSym(i);
        for(int z = 0;z<ans.size();z++){
            if(ans[z] == afterSym) return;
        }
    }
    ans.push_back(curr);
    NotAdded = -1;
}
void GetScans(){
    if(length == n-2){
        add();
        NotAdded++;
        return;
    }
    for(int edge = 1;edge<m;edge++){
        int i = pairs[edge].first;
        int z = pairs[edge].second;
        if(!used[i]) swap(i,z);
        if(used[i] == used[z]) continue;
        used[z] = 1;
        curr[edge] = 1;
        length++;
        GetScans();
        if(ans.size() == 15) return;
        length--;
        curr[edge] = 0;
        used[z] = 0;
    }
}
void GetSyms(){
    int last = CurrSym.size()-1;
    for(int i = 1;i<last;i++){
        if((bool)edges[last][i] != (bool)edges[CurrSym[i]][CurrSym[last]])
            return;
    }
    if(CurrSym.size() == n){
        sym.push_back(CurrSym);
        return;
    }
    for(int i = 0;i<n;i++){
        if(used[i]) continue;
        used[i] = 1;
        CurrSym.push_back(i);
        GetSyms();
        used[i] = 0;
        CurrSym.pop_back();
    }
}
void FileOut(){
    freopen("polyedr.out","w",stdout); /// rename!
    for(int i = 0;i<ans.size();i++){
        for(int z = 1;z<m;z++){
            if(ans[i][z]) printf("%3d",z);
        }
        cout << endl;
    }
}
int main(){
    ReadData();
    used.assign(n,0);
    GetSyms();
    used.assign(n,0);
    used[1] = 1;
    GetScans();
    FileOut();
}
