/* GCC */
#include<bits/stdc++.h>

using namespace std;

int n, m;
int num[20][20];
pair<int, int> edge[40];
bool used[20];
vector<bool> ed_used, res;
vector<vector<bool> > ans;
vector<vector<int> > sym;
vector<int> cur;

void get_symetry() {
    int k = cur.size()-1;
    for(int i = 0;i < k;++i)
    if((num[i][k] == 0) != (num[cur[i]][cur[k]] == 0))
        return;
    if(k == n-1) {
        sym.push_back(cur);
        return;
    }
    for(int i = 0;i < n;++i) {
        if(used[i])
            continue;
        cur.push_back(i);
        used[i] = true;
        get_symetry();
        cur.pop_back();
        used[i] = false;
    }
}

void make_sym(int k) {
    res.assign(m, false);
    int a, b;
    for(int i = 0;i < m;++i)
    if(ed_used[i]) {
        a = sym[k][edge[i].first];
        b = sym[k][edge[i].second];
        res[num[a][b] - 1] = true;
    }
}

void add() {
    for(int i = 0;i < sym.size();++i) {
        make_sym(i);
        for(int j = 0;j < ans.size();++j)
        if(ans[j] == res)
            return;
    }
    ans.push_back(ed_used);
}
void solve(int k = 0) {
    if(ans.size() >= 15)
        return;
    if(k == n-1) {
        add();
        return;
    }
    int a, b;
    for(int i = 0;i < m;++i) {
        if(ed_used[i])
            continue;
        a = edge[i].first;
        b = edge[i].second;
        if(used[a] == used[b])
            continue;
        if(used[b])
            swap(a, b);
        used[b] = true;
        ed_used[i] = true;
        solve(k+1);
        used[b] = false;
        ed_used[i] = false;
    }
}
int main() {
    freopen("polyedr.in", "r", stdin);
    freopen("polyedr.out", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    string s;
    stringstream ss;

    vector<int> arr;
    int to;

    while(getline(cin, s)) {
        ss.clear();
        arr.clear();
        ss.str(s);
        while(ss >> to)
            arr.push_back(to-1);

        sort(arr.begin(), arr.end());
        for(int i = 0;i < arr.size();++i) {
            if(arr[i] < n)
                num[n][arr[i]] = num[arr[i]][n];
            else {
                edge[m] = make_pair(n, arr[i]);
                num[n][arr[i]] = ++m;
            }
        }
        n++;
    }

    ed_used.resize(m, false);
    get_symetry();
    used[0] = true;
    solve();

    for(int i = 0;i < ans.size();++i) {
        for(int j = 0;j < m;++j)
        if(ans[i][j])
            cout << setw(3) << j+1;
        cout << '\n';
    }
    return 0;
}
