/* GCC */
#include <iostream>
#include <stdio.h>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <sstream>
#include <vector>
#include <string>

using namespace std;

vector<int> arr(10010, 0);

int findLeft(int currStart, int currEnd)
{
    int maxn=0, maxi;
    for (int i=currEnd-1; i>=currStart; i--){
        if (arr[i] > maxn){
            maxn = arr[i];
            maxi = i;
        }
    }
    return maxi;
}

int main(void)
{
    ifstream fin("cover.in");
    ofstream fout("cover.out");

    int i, z, goal[2];
    fin >> goal[0] >> goal[1];
    while ( !fin.eof() ){
        fin >> i >> z;
        if (z > arr[i])
            arr[i] = z;
    }

    vector<int> ans;

    int currStart=0, currEnd=goal[0];
    while (currEnd <= goal[1]){
        currStart = findLeft(currStart, currEnd);
        currEnd = arr[currStart];
        ans.push_back(currStart);
        ans.push_back(currEnd);
    }

    fout << ans[0];
    for (int i=1; i<ans.size(); i++)
        fout << " " << ans[i];
    fout << "\n";

    fin.close();
    fout.close();

    return 0;
}
