/* GCC */
#include <iostream>
#include <stdio.h>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <sstream>
#include <vector>
#include <string>

using namespace std;

int n=21, m=1;
vector< pair<int, int> > pairs(1);
vector< vector<int> > edges(n, vector<int>(m, 0));
vector<bool> curr;


void readData(void)
{
    freopen("polyedr.in", "r", stdin);
    string s;
    int i=0, z;
    while(getline(cin, s)){
        i++;
        vector<int> dots;
        stringstream ss(s);
        while ( !ss.eof() ){
            ss >> z;
            dots.push_back(z);
        }
        sort(dots.begin(), dots.end());
        for (z=0; z<dots.size(); z++){
            if (dots[z] < i) continue;
            edges[i][dots[z]] = edges[dots[z]][i] = m++;
            pairs.push_back( make_pair(i, dots[z]) );
        }
    }
    n = i;
    curr.assign(m, false);

    fclose(stdin);
}

vector< vector<int> > ans;

vector<int> F(vector<bool> a, int h)
{
    if (h == pairs.size()){
        vector<int> res;
        for (int i=0; i<a.size(); i++)
            if (a[i]) res.push_back(i);
        return res;
    }

    F(a, h+1);

    a[ pairs[h].second ] = true;
    F(a, h+1);
}

int main(void)
{
    freopen("polyedr.out", "w", stdout);

    readData();

    int x, y;
    for (int i=0; i<pairs.size() && pairs[i].first==1; i++){
        vector<bool> a(100, false);
        a[1] = true;
        F(a, i);
    }

    for (int i=0; i<ans.size(); i++){
        for (int j=0; j<ans[i].size(); j++)
            cout << ans[i][j] << " ";
        cout << "\n";
    }

    return 0;
}

