/* GCC */
#include <bits/stdc++.h>
using namespace std;
#define scan vector<bool>
int n =21, m = 1, len;
vector<vector<int> > edges(n, vector<int>(n)), sym;
vector<scan> ans;
scan used, afterSym, cur;
vector<int> curSym(1);
vector<pair<int, int> > pairs(1);
void read()
{
    string s;
    int i =0, z;
    while(getline(cin, s))
    {
        i++;
        stringstream ss(s);
        vector<int> dots;
        while(!ss.eof())
        {
            ss>>z;
            dots.push_back(z);
        }
        sort(dots.begin(), dots.end());
        for(z=0; z<dots.size(); z++)
        {
            if(i>dots[z]) continue;
            edges[i][dots[z]] = edges[dots[z]][i] = m++;
            pairs.push_back(make_pair(i, dots[z]));
        }
    }
    n = i+1;
    cur.assign(m, 0);
}
scan getSym(int a)
{
    scan b(m, 0);
    for(int i =1; i<m; i++)
    {
        if(cur[i])
        {
            int face1 = pairs[i].first;
            int face2 = pairs[i].second;
            face1 = sym[a][face1];
            face2 = sym[a][face2];
            b[edges[face1][face2]] = true;
        }
    }
    return b;
}
void add()
{
    for(int i =0; i<sym.size(); i++)
    {
        afterSym = getSym(i);
        for(int j =0; j<ans.size(); j++)
            if(ans[j] == afterSym)
        {
            return;
        }
    }
    ans.push_back(cur);
}
void findScans()
{
    if(len == n - 2)
    {
        add();
        return;
    }
    for(int edge =1; edge<m; edge++)
    {
        int i = pairs[edge].first;
        int j = pairs[edge].second;
        if(!used[i]) swap(i, j);
        if(used[i] == used[j]) continue;
        used[j] =true;
        len++;
        cur[edge] = true;
        findScans();
        if(ans.size() == 15)
            return;
        len--;
        cur[edge] = false;
        used[j] = false;
    }
}
void findSyms()
{
    int last = curSym.size() - 1;
    for(int i =1; i<last; i++)
    {
        if((bool)edges[i][last] != (bool)edges[curSym[i]][curSym[last]])
        {
            return;
        }
    }
    if(curSym.size() == n)
    {
        sym.push_back(curSym);
        return;
    }
    for(int i =1; i<n; i++)
    {
        if(used[i]) continue;
        used[i] = true;
        curSym.push_back(i);
        findSyms();
        used[i] = false;
        curSym.pop_back();
    }
}
void print()
{
    for(int i =0; i<ans.size(); i++)
    {
        for(int j =0; j<ans[i].size(); j++)
        {
            if(ans[i][j])
            {
                printf("%3d", j);
            }
        }
        printf("\n");
    }
}
int main()
{
    freopen("polyedr.in", "r", stdin);
    freopen("polyedr.out", "w", stdout);
    read();
    used.assign(n, 0);
    findSyms();
    used.assign(n, 0);
    used[1] = true;
    findScans();
    print();
    return 0;
}
