/*GCC*/
#include <bits/stdc++.h>

using namespace std;

long n = 0,m = 1,in = 1;
long e[40][40];
vector<pair<long,long> >es;
vector<bool>u,ue;
vector<vector<long> > syms;
vector<vector<bool> > ans;

vector<bool> trans(long j){
    vector<bool>temp(m,0);
    for(long i = 0;i < m-1;i++){
        if(!ue[i])continue;
        long a = syms[j][es[i].first],
                b = syms[j][es[i].second];
        temp[e[a][b] - 1] = 1;
    }
    return temp;
}

void add(){
    for(long i = 0;i < syms.size();i++){
        vector<bool>temp = trans(i);
        for(long j = 0;j < ans.size();j++)
            if(ans[j] == temp)
                return;
    }
    ans.push_back(ue);
}

void GetAns(){
    if(ans.size() > 14)
            return;
    if(in == n){
        add();
        return;
    }
    for(long i = 0;i < m-1;i++){
        long a = es[i].first,
                b = es[i].second;
        if(!u[a] || u[b])
            swap(a,b);
        if(!u[a] || u[b])
            continue;
        u[b] = 1;
        ue[i] = 1;
        in++;
        GetAns();
        in--;
        u[b] = 0;
        ue[i] = 0;
    }
}

vector<long>cur;

bool edge(long a,long b){
    return e[a][b] > 0;
}

void GetSym(){
    long last = cur.size() - 1;
    for(long i = 0;i < last;i++){
        if(edge(i,last) != edge(cur[i],cur[last]))
            return;
    }
    if(cur.size() == n){
        syms.push_back(cur);
        return;
    }
    for(long i = 0;i < n;i++){
        if(u[i])continue;
        u[i] = 1;
        cur.push_back(i);
        GetSym();
        cur.pop_back();
        u[i] = 0;
    }
}

int main()
{
    freopen("polyedr.in","r",stdin);
    freopen("polyedr.out","w",stdout);
    es.clear();
    ans.clear();
    syms.clear();
    string s;
    while(getline(cin,s)){
        stringstream ss(s);
        vector<long>t(0);
        long temp;
        while(ss >> temp){
            temp--;
            t.push_back(temp);
        }
        sort(t.begin(),t.end());
        for(long i = 0;i < t.size();i++){
            if(t[i] > n){
                e[n][t[i]] = e[t[i]][n] = m++;
                es.push_back(make_pair(n,t[i]));
            }
        }
        n++;
    }
    u.assign(n,0);
    cur.clear();
    GetSym();
    u.assign(n,0);
    ue.assign(m,0);
    u[0] = 1;
    GetAns();
    for(long i = 0;i < ans.size();i++){
        for(long j = 0;j < ans[i].size();j++)
        if(ans[i][j])printf("%3d",j + 1);
        printf("\n");
    }
    return 0;
}
